=== debian/changelog ===
qemu (1.5.0+dfsg-3ubuntu5) saucy; urgency=low

  * Cherrypick upstream patch to fix crash with rng device (LP: #1235017)
    - virtio-rng-fix-crash

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 09 Oct 2013 17:46:49 -0500

qemu (1.5.0+dfsg-3ubuntu4) saucy; urgency=low

  * Re-introduce snippet in upstart job to load kvm modules if needed.
    (LP: #1218459)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 16 Sep 2013 22:43:52 +0000

qemu (1.5.0+dfsg-3ubuntu3) saucy; urgency=low

  * Cherry-picking three Xen related patches targetted for qemu-stable:
    * xen-simplify-xen_enabled.patch
    * main_loop-do-not-set-nonblocking-if-xen_enabled.patch
    * xen_machine_pv-do-not-create-a-dummy-CPU-in-machine-.patch

 -- Stefan Bader <stefan.bader@canonical.com>  Fri, 26 Jul 2013 15:01:44 +0200

qemu (1.5.0+dfsg-3ubuntu2) saucy; urgency=low

  * Drop openbios-ppc and openhackware Depends to Suggests for now.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 05 Jun 2013 03:23:56 -0600

qemu (1.5.0+dfsg-3ubuntu1) saucy; urgency=low

  * Merge 1.5.0+dfs-3 from debian unstable.  Remaining changes:
    - debian/control
      * update maintainer
      * remove libiscsi, usb-redir, vde, vnc-jpeg, and libssh2-1-dev
        from build-deps
      * enable rbd
      * add qemu-system and qemu-common B/R to qemu-keymaps
      * add D:udev, R:qemu, R:qemu-common and B:qemu-common to
        qemu-system-common
      * qemu-system-arm, qemu-system-ppc, qemu-system-sparc:
        - add qemu-kvm to Provides
        - add qemu-common, qemu-kvm, kvm to B/R
        - remove openbios-sparc from qemu-system-sparc D
      * qemu-system-x86:
        - add qemu-common to Breaks/Replaces.
        - add cpu-checker to Recommends.
      * qemu-user: add B/R:qemu-kvm
      * qemu-kvm:
        - add armhf armel powerpc sparc to Architecture
        - C/R/P: qemu-kvm-spice
      * add qemu-common package
      * drop qemu-slof which is not packaged in ubuntu
    - add qemu-system-common.links for tap ifup/down scripts and OVMF link.
    - qemu-system-x86.links:
      * remove pxe rom links which are in kvm-ipxe
      * add symlink for kvm.1 manpage
    - debian/rules
      * add kvm-spice symlink to qemu-kvm
      * call dh_installmodules for qemu-system-x86
      * update dh_installinit to install upstart script
      * run dh_installman (Closes: #709241) (cherrypicked from 1.5.0+dfsg-2)
    - Add qemu-utils.links for kvm-* symlinks.
    - Add qemu-system-x86.qemu-kvm.upstart and .default
    - Add qemu-system-x86.modprobe to set nesting=1
    - Add qemu-system-common.preinst to add kvm group
    - qemu-system-common.postinst: remove bad group acl if there, then have
      udev relabel /dev/kvm.
    - Dropped patches:
      * 0001-fix-wrong-output-with-info-chardev-for-tcp-socket.patch
    - Kept patches:
      * expose_vms_qemu64cpu.patch - updated
      * gridcentric patch - updated
      * linaro arm patches from qemu-linaro rebasing branch

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 04 Jun 2013 22:56:43 +0200

qemu (1.5.0+dfsg-3) unstable; urgency=low

  * fix sections: misc => otherosfs
  * remove obsolete conffiles (kvm-ifup, kvm-ifdown, target-x86_64.conf)
    from /etc/kvm/ in qemu-kvm (Closes: #710328)
  * rework debian/rules a bit, to build various bits depending on
    which packages are requested, not depending on ad-hoc host/arch
    logic
  * do not fail at install if kvm module loading failed on x86 or
    if modprobe isn't installed (Closes: #710496)
  * also suggest kmod to be able to load x86 kvm modules
  * suggest sgabios for qemu-system-x86 and put a symlink to sgabios.bin
    (Closes: #696985)
  * add rules to build just one of arch/indep parts, to make
    buildd log scanner happier (E-binary-arch-produces-all)
  * use verbose build by default (V=1) and let it to be overridden

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 02 Jun 2013 01:49:47 +0400

qemu (1.5.0+dfsg-2ubuntu1) saucy; urgency=low

  * Merge 1.5.0+dfs-2 from debian unstable.  Remaining changes:
    - debian/control
      * update maintainer
      * remove libiscsi, usb-redir, vde, vnc-jpeg, and libssh2-1-dev
        from build-deps
      * enable rbd
      * add qemu-system and qemu-common B/R to qemu-keymaps
      * add D:udev, R:qemu, R:qemu-common and B:qemu-common to
        qemu-system-common
      * qemu-system-arm, qemu-system-ppc, qemu-system-sparc:
        - add qemu-kvm to Provides
        - add qemu-common, qemu-kvm, kvm to B/R
        - remove openbios-sparc from qemu-system-sparc D
      * qemu-system-x86:
        - add qemu-common to Breaks/Replaces.
        - add cpu-checker to Recommends.
      * qemu-user: add B/R:qemu-kvm
      * qemu-kvm:
        - add armhf armel powerpc sparc to Architecture
        - C/R/P: qemu-kvm-spice
      * add qemu-common package
      * drop qemu-slof which is not packaged in ubuntu
    - add qemu-system-common.links for tap ifup/down scripts and OVMF link.
    - qemu-system-x86.links:
      * remove pxe rom links which are in kvm-ipxe
      * add symlink for kvm.1 manpage
    - debian/rules
      * add kvm-spice symlink to qemu-kvm
      * call dh_installmodules for qemu-system-x86
      * update dh_installinit to install upstart script
      * run dh_installman (Closes: #709241) (cherrypicked from 1.5.0+dfsg-2)
    - Add qemu-utils.links for kvm-* symlinks.
    - Add qemu-system-x86.qemu-kvm.upstart and .default
    - Add qemu-system-x86.modprobe to set nesting=1
    - Add qemu-system-common.preinst to add kvm group
    - qemu-system-common.postinst: remove bad group acl if there, then have
      udev relabel /dev/kvm.
    - Dropped patches:
      * 0001-fix-wrong-output-with-info-chardev-for-tcp-socket.patch
    - Kept patches:
      * expose_vms_qemu64cpu.patch - updated
      * gridcentric patch - updated
      * linaro arm patches from qemu-linaro rebasing branch

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 28 May 2013 08:18:30 -0500

qemu (1.5.0+dfsg-2) unstable; urgency=low


